#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_finalizer4xi.py">
#<abstract4xi abstract = "providing init_finalizers4xi function"/>
#<refer4xi reference = "DragonXi"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_finalizer4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import itertools
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from finalizer4xi import init_finalizer_registry4xi
from finalizer4xi import clear_finalizer_registry4xi
from finalizer4xi import init_finalizer_counter4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "finalizer4xi" usage = "
#    finalizes
#">                           
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>

# -------------------------------------------------------------------------------------------------
def _finalizer4xi():

    '''
    finalizes
    '''

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
      
    class2print = "_finalizer4xi"
    method2print = "_finalizer4xi"
    
    message2print = "{started" + "; finalizer4xi-started: " + str(_finalizer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    init_finalizer_registry4xi()
    
    message2print = "{performed" + "; init-finalizer-registry4xi-performed-by-finalizer4xi: " + str(init_finalizer_registry4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
           
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
       
    init_finalizer_counter4xi()
    
    message2print = "{performed" + "; init-finalizer-counter4xi-performed-by-finalizer4xi: " + str(init_finalizer_counter4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
              
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                   
    message2print = "{returning" + "; finalizer4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
            
#</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_finalizer4xi.txt
#   sense-test-finalizer4xi.xml
#   reason-test-finalizer4xi.xml
#   ace-test-finalizer4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _finalizer4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
